import {
  scaleLinear,
  extent,
  axisLeft,
  axisBottom,
  symbols,
  symbol,
  scaleOrdinal
} from 'd3';
// getting all the elements


export const scatterPlot = () => {
  let width;
  let height;
  let data;
  let xValue;
  let yValue;
  let symbolValue;
  let margin;
  let radius;
  const colorValue = d => d.species;
        const colorScale = d3.scaleOrdinal()
        .range(["#eb8e37", "#1ac6cf", "#e35dd4"]);
 // chart instance
  const my = (selection) => {
    const x = scaleLinear()     // x scale function
      .domain(extent(data, xValue))
      .range([margin.left, width - margin.right]);

    const y = scaleLinear()    // y scale function
      .domain(extent(data, yValue))
      .range([height - margin.bottom, margin.top]);

    const symbolScale = scaleOrdinal()  // symbol type
    .domain(data.map(symbolValue))
    .range(symbols);
// Generating the symbols    
    const symbolGenerator =  symbol()
    
    const marks = data.map((d) => ({
      x: x(xValue(d)),
      y: y(yValue(d)),
      pathD: symbolGenerator.type(symbolScale(symbolValue(d)))(),
    }));

    const circles = selection
      .selectAll('path')
      .data(marks)
      .join('path')
    	.attr('d',d => d.pathD)
      .attr('transform', (d) => `translate(${d.x},${d.y})`);

    	;
  const colorScale = scaleOrdinal()
    	.domain(data)
  	.range(sectionColors);
    
    selection
      .selectAll('.y-axis')
      .data([null])
      .join('g')
      .attr('class', 'y-axis')
      .attr('transform', `translate(${margin.left},0)`)
      .call(axisLeft(y))
    colorScale
          .domain(d3.set(data.map(colorValue)).values().sort());
    	

    selection
      .selectAll('.x-axis')
      .data([null])
      .join('g')
      .attr('class', 'x-axis')
      .attr(
        'transform',
        `translate(0,${height - margin.bottom})`
      )
      .call(axisBottom(x))
    
     colorScale
          .domain(d3.set(data.map(colorValue)).values().sort());
    
    
  };

  // setters and getters
  
  my.width = function (_) {
    return arguments.length ? ((width = +_), my) : width;
  };

  my.height = function (_) {
    return arguments.length ? ((height = +_), my) : height;
  };

  my.data = function (_) {
    return arguments.length ? ((data = _), my) : data;
  };

  my.xValue = function (_) {
    return arguments.length ? ((xValue = _), my) : xValue;
  };

  my.yValue = function (_) {
    return arguments.length ? ((yValue = _), my) : yValue;
  };
  
   my.symbolValue = function (_) {
    return arguments.length ? ((symbolValue = _), my) : symbolValue;
  };


  my.margin = function (_) {
    return arguments.length ? ((margin = _), my) : margin;
  };

  my.radius = function (_) {
    return arguments.length ? ((radius = +_), my) : radius;
  };

  return my;
};
